--[[
    Stable by LordFarlander
    Version 1.1
    $Revision: 75749 $

    Based on Kennel.
]]--

--[[
Copyright (c) 2008, LordFarlander
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

    * Redistributions of source code must retain the above copyright notice,
      this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice,
      this list of conditions and the following disclaimer in the documentation
      and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
]]--

local L = AceLibrary( "AceLocale-2.2" ):new( "Stable" );

local options = {
        type = "group",
        args = {
            [L["swapMinipets"]] = {
                type = "toggle",
                name = L["Swap Minipets"],
                desc = L["Toggles the swapping of minipets."],
                get = function()
                          return Stable.db.char.DoSwap["MiniPets"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["MiniPets"] = not Stable.db.char.DoSwap["MiniPets"];
                      end,
            },
            [L["swapMinipetsNormal"]] = {
                type = "toggle",
                name = L["Swap Normal Minipets"],
                desc = L["Toggles the swapping of normal minipets."],
                get = function()
                          return Stable.db.char.DoSwap["MiniPets.Normal"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["MiniPets.Normal"] = not Stable.db.char.DoSwap["MiniPets.Normal"];
                      end,
            },
            [L["swapMinipetsReagented"]] = {
                type = "toggle",
                name = L["Swap Reagented Minipets"],
                desc = L["Toggles the swapping of reagented minipets (eg needs a snowball to summon)."],
                get = function()
                          return Stable.db.char.DoSwap["MiniPets.Reagented"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["MiniPets.Reagented"] = not Stable.db.char.DoSwap["MiniPets.Reagented"];
                      end,
            },
            [L["swapMountsGround"]] = {
                type = "toggle",
                name = L["Swap Ground Mounts"],
                desc = L["Toggles the swapping of ground mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Ground"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Ground"] = not Stable.db.char.DoSwap["Mounts.Ground"];
                      end,
            },
            [L["swapMountsGroundSlow"]] = {
                type = "toggle",
                name = L["Swap Slow Ground Mounts"],
                desc = L["Toggles the swapping of slow (running speed) ground mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Ground.Slow"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Ground.Slow"] = not Stable.db.char.DoSwap["Mounts.Ground.Slow"];
                      end,
            },
            [L["swapMountsGroundFast"]] = {
                type = "toggle",
                name = L["Swap Fast Ground Mounts"],
                desc = L["Toggles the swapping of fast (+60% running speed) ground mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Ground.Fast"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Ground.Fast"] = not Stable.db.char.DoSwap["Mounts.Ground.Fast"];
                      end,
            },
            [L["swapMountsGroundVeryFast"]] = {
                type = "toggle",
                name = L["Swap Very Fast Ground Mounts"],
                desc = L["Toggles the swapping of very fast (+100% running speed) ground mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Ground.VeryFast"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Ground.VeryFast"] = not Stable.db.char.DoSwap["Mounts.Ground.VeryFast"];
                      end,
            },
            [L["swapMountsFlying"]] = {
                type = "toggle",
                name = L["Swap Flying Mounts"],
                desc = L["Toggles the swapping of fast (+60% ground/+60% flying speed) flying mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Flying"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Flying"] = not Stable.db.char.DoSwap["Mounts.Flying"];
                      end,
            },
            [L["swapMountsFlyingFast"]] = {
                type = "toggle",
                name = L["Swap Fast Flying Mounts"],
                desc = L["Toggles the swapping of fast (+60% ground/+60% flying speed) flying mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Flying.Fast"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Flying.Fast"] = not Stable.db.char.DoSwap["Mounts.Flying.Fast"];
                      end,
            },
            [L["swapMountsFlyingVeryFast"]] = {
                type = "toggle",
                name = L["Swap Very Fast Flying Mounts"],
                desc = L["Toggles the swapping of very fast (+100% ground/+280% flying speed) flying mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Flying.VeryFast"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Flying.VeryFast"] = not Stable.db.char.DoSwap["Mounts.Flying.VeryFast"];
                      end,
            },
            [L["swapMountsFlyingExtremelyFast"]] = {
                type = "toggle",
                name = L["Swap Extremely Fast Flying Mounts"],
                desc = L["Toggles the swapping of extremely fast (+100% ground/+310% flying speed) flying mounts."],
                get = function()
                          return Stable.db.char.DoSwap["Mounts.Flying.ExtremelyFast"];
                      end,
                set = function( val )
                          Stable.db.char.DoSwap["Mounts.Flying.ExtremelyFast"] = not Stable.db.char.DoSwap["Mounts.Flying.ExtremelyFast"];
                      end,
            },
        },
    };

Stable = AceLibrary( "AceAddon-2.0" ):new( "AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0" );
Stable.version = tonumber( string.match( "$Rev: 75749 $", "(%d+)" ) );
Stable:RegisterChatCommand( "/Stable", "/stbl", options );
Stable:RegisterDB( "StableDB", "StableDBPC" );
Stable:RegisterDefaults( "char", {
        DoSwap = { ["MiniPets"] = true, ["MiniPets.Normal"] = true, ["MiniPets.Reagented"] = true,
            ["Mounts.Ground"] = true, ["Mounts.Ground.Slow"] = true, ["Mounts.Ground.Slow"] = true, ["Mounts.Ground.Fast"] = true, ["Mounts.Ground.VeryFast"] = true,
            ["Mounts.Flying"] = true, ["Mounts.Flying.Fast"] = true, ["Mounts.Flying.VeryFast"] = true, ["Mounts.Flying.ExtremelyFast"] = true, },
    } );

local PetAndMountDatabase = LibStub( "PetAndMountDatabase-1.0" );

Stable.bankopen = false;
Stable.swapped = false;
Stable.sets = {
        ["MiniPets"] = {
                normal = { player = {bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "MiniPets.Normal", },
                reagented = { player = {bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "MiniPets.Reagented", },
            },
        ["Mounts.Ground"] = {
                slow = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Ground.Slow", },
                fast = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Ground.Fast", },
                veryfast = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Ground.VeryFast", },
            },
        ["Mounts.Flying"] = {
                fast = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Flying.Fast", },
                veryfast = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Flying.VeryFast", },
                extremelyfast = { player = { bag = {}, slot = {}, num = 0 }, bank = { bag = {}, slot = {}, num = 0 }, set = "Mounts.Flying.ExtremelyFast", },
            },
    };

function Stable:OnEnable()
    self:RegisterEvent( "BANKFRAME_OPENED" );
    self:RegisterEvent( "BANKFRAME_CLOSED",
        function()
            if( Stable.bankopen and Stable.swapped and FuBar_CorkFu ) then
                FuBar_CorkFu:GetModule( "Minipet" ):ActivatePet();
            end--if
            if( ( not Stable.bankopen ) and ( not Stable.swapped ) ) then
                Stable:BANKFRAME_OPENED();
            end--if
            Stable.bankopen = false;
        end );

    --Convert old save values
    if( self.db.char.DoSwap["GroundMounts"] ~= nil ) then
        self.db.char.DoSwap["Mounts.Ground"] = self.db.char.DoSwap["GroundMounts"];
        self.db.char.DoSwap["GroundMounts"] = nil;
    end--if
    if( self.db.char.DoSwap["FlyingMounts"] ~= nil ) then
        self.db.char.DoSwap["Mounts.Flying"] = self.db.char.DoSwap["FlyingMounts"];
        self.db.char.DoSwap["FlyingMounts"] = nil;
    end--if
    if( self.db.char.DoSwap["MiniPets.Holiday"] ~= nil ) then
        self.db.char.DoSwap["MiniPets.Reagented"] = self.db.char.DoSwap["MiniPets.Holiday"];
        self.db.char.DoSwap["MiniPets.Holiday"] = nil;
    end--if
    --Upgrade check
    if( self.db.char.LastVersion == nil ) then
        self.db.char.DoSwap["MiniPets.Normal"] = true;
        self.db.char.DoSwap["MiniPets.Reagented"] = true;
        self.db.char.DoSwap["Mounts.Ground.Slow"] = true;
        self.db.char.DoSwap["Mounts.Ground.Fast"] = true;
        self.db.char.DoSwap["Mounts.Ground.VeryFast"] = true;
        self.db.char.DoSwap["Mounts.Flying.Fast"] = true;
        self.db.char.DoSwap["Mounts.Flying.VeryFast"] = true;
        self.db.char.DoSwap["Mounts.Flying.ExtremelyFast"] = true;
    end--if
    if( self.db.char.LastVersion ~= self.version ) then
        self.db.char.LastVersion = self.version;
    end--if
end--Stable:OnEnable()

function Stable:BANKFRAME_OPENED()
    local stableSets = self.sets;
    local doSwap = self.db.char.DoSwap;
    
    self.bankopen = true;
    self.swapped = false;
    
    for _, set in pairs( stableSets ) do
        for _, subset in pairs( set ) do
            subset.player.num = 0;
            subset.bank.num = 0;
        end--for
    end--for
    for bag = BANK_CONTAINER, NUM_BAG_SLOTS + NUM_BANKBAGSLOTS do
        local bagset = ( bag <= NUM_BAG_SLOTS and bag >= 0 ) and "player" or "bank";
    
        for slot = 1, GetContainerNumSlots( bag ) do
            for setName, set in pairs( stableSets ) do
                if( doSwap[setName] ) then
--                    swappingMiniPets = setName == "MiniPets";

                    for _, subset in pairs( set ) do
                        itemLink = GetContainerItemLink( bag, slot );
--                        if( itemLink and doSwap[subset.set] and ( ( ( swappingMiniPets and bit.band( GetItemFamily( itemLink ), 4096 ) ~= 0 ) ) or PetAndMountDatabase:ItemInSet( itemLink, subset.set ) ) ) then
                        if( itemLink and doSwap[subset.set] and PetAndMountDatabase:ItemInSet( itemLink, subset.set ) ) then
                            local petSet = subset[bagset];
                            local n = petSet.num + 1;
    
                            petSet.num = n;
                            petSet.bag[n] = bag;
                            petSet.slot[n] = slot;
                        end--if
                    end--for
                end--if
            end--for
        end--for
    end--for
    for setName, set in pairs( stableSets ) do
        if( doSwap[setName] ) then
            for _, subset in pairs( set ) do
                if( doSwap[subset.set] ) then
                    self.swapped = self:DoSwaps( subset ) or self.swapped;
                end--if
            end--for
        end--if
    end--for
end--Stable:BANKFRAME_OPENED()

------------------------------
--     Helper Functions     --
------------------------------
function Stable:DoSwaps( set )
    if set.player.num > set.bank.num then
        set.player, set.bank = set.bank, set.player;
    end--if

    local p, b = set.player, set.bank;

    if( p.num == 0 ) then
        return false;
    end--if
    for i = 1, p.num do
        local r = math.random( b.num + 1 - i );

        PickupContainerItem( p.bag[i], p.slot[i] );
        PickupContainerItem( b.bag[r], b.slot[r] );
        table.remove( b.bag, r );
        table.remove( b.slot, r );
    end--for
    return ( p.num > 0 ) and ( b.num > 0 );
end--Stable:DoSwaps( set )